/*
' Copyright (c) 2012 DotNetNuke Corporation
'  All rights reserved.
' 
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
' DEALINGS IN THE SOFTWARE.
' 
*/

using System.Collections.Generic;
//using System.Xml;
using DotNetNuke.Entities.Modules;
using DotNetNuke.Services.Search;

namespace DotNetNuke.Modules.GPHosting_DNN_Contact_Form.Components
{

    /// -----------------------------------------------------------------------------
    /// <summary>
    /// The Controller class for GPHosting_DNN_Contact_Form
    /// 
    /// The FeatureController class is defined as the BusinessController in the manifest file (.dnn)
    /// DotNetNuke will poll this class to find out which Interfaces the class implements. 
    /// 
    /// The IPortable interface is used to import/export content from a DNN module
    /// 
    /// The ISearchable interface is used by DNN to index the content of a module
    /// 
    /// The IUpgradeable interface allows module developers to execute code during the upgrade 
    /// process for a module.
    /// 
    /// Below you will find stubbed out implementations of each, uncomment and populate with your own data
    /// </summary>
    /// -----------------------------------------------------------------------------

    //uncomment the interfaces to add the support.
    public class FeatureController //: IPortable, ISearchable, IUpgradeable
    {


        #region Optional Interfaces

        /// -----------------------------------------------------------------------------
        /// <summary>
        /// ExportModule implements the IPortable ExportModule Interface
        /// </summary>
        /// <param name="ModuleID">The Id of the module to be exported</param>
        /// -----------------------------------------------------------------------------
        //public string ExportModule(int ModuleID)
        //{
        //string strXML = "";

        //List<GPHosting_DNN_Contact_FormInfo> colGPHosting_DNN_Contact_Forms = GetGPHosting_DNN_Contact_Forms(ModuleID);
        //if (colGPHosting_DNN_Contact_Forms.Count != 0)
        //{
        //    strXML += "<GPHosting_DNN_Contact_Forms>";

        //    foreach (GPHosting_DNN_Contact_FormInfo objGPHosting_DNN_Contact_Form in colGPHosting_DNN_Contact_Forms)
        //    {
        //        strXML += "<GPHosting_DNN_Contact_Form>";
        //        strXML += "<content>" + DotNetNuke.Common.Utilities.XmlUtils.XMLEncode(objGPHosting_DNN_Contact_Form.Content) + "</content>";
        //        strXML += "</GPHosting_DNN_Contact_Form>";
        //    }
        //    strXML += "</GPHosting_DNN_Contact_Forms>";
        //}

        //return strXML;

        //	throw new System.NotImplementedException("The method or operation is not implemented.");
        //}

        /// -----------------------------------------------------------------------------
        /// <summary>
        /// ImportModule implements the IPortable ImportModule Interface
        /// </summary>
        /// <param name="ModuleID">The Id of the module to be imported</param>
        /// <param name="Content">The content to be imported</param>
        /// <param name="Version">The version of the module to be imported</param>
        /// <param name="UserId">The Id of the user performing the import</param>
        /// -----------------------------------------------------------------------------
        //public void ImportModule(int ModuleID, string Content, string Version, int UserID)
        //{
        //XmlNode xmlGPHosting_DNN_Contact_Forms = DotNetNuke.Common.Globals.GetContent(Content, "GPHosting_DNN_Contact_Forms");
        //foreach (XmlNode xmlGPHosting_DNN_Contact_Form in xmlGPHosting_DNN_Contact_Forms.SelectNodes("GPHosting_DNN_Contact_Form"))
        //{
        //    GPHosting_DNN_Contact_FormInfo objGPHosting_DNN_Contact_Form = new GPHosting_DNN_Contact_FormInfo();
        //    objGPHosting_DNN_Contact_Form.ModuleId = ModuleID;
        //    objGPHosting_DNN_Contact_Form.Content = xmlGPHosting_DNN_Contact_Form.SelectSingleNode("content").InnerText;
        //    objGPHosting_DNN_Contact_Form.CreatedByUser = UserID;
        //    AddGPHosting_DNN_Contact_Form(objGPHosting_DNN_Contact_Form);
        //}

        //	throw new System.NotImplementedException("The method or operation is not implemented.");
        //}

        /// -----------------------------------------------------------------------------
        /// <summary>
        /// GetSearchItems implements the ISearchable Interface
        /// </summary>
        /// <param name="ModInfo">The ModuleInfo for the module to be Indexed</param>
        /// -----------------------------------------------------------------------------
        //public DotNetNuke.Services.Search.SearchItemInfoCollection GetSearchItems(DotNetNuke.Entities.Modules.ModuleInfo ModInfo)
        //{
        //SearchItemInfoCollection SearchItemCollection = new SearchItemInfoCollection();

        //List<GPHosting_DNN_Contact_FormInfo> colGPHosting_DNN_Contact_Forms = GetGPHosting_DNN_Contact_Forms(ModInfo.ModuleID);

        //foreach (GPHosting_DNN_Contact_FormInfo objGPHosting_DNN_Contact_Form in colGPHosting_DNN_Contact_Forms)
        //{
        //    SearchItemInfo SearchItem = new SearchItemInfo(ModInfo.ModuleTitle, objGPHosting_DNN_Contact_Form.Content, objGPHosting_DNN_Contact_Form.CreatedByUser, objGPHosting_DNN_Contact_Form.CreatedDate, ModInfo.ModuleID, objGPHosting_DNN_Contact_Form.ItemId.ToString(), objGPHosting_DNN_Contact_Form.Content, "ItemId=" + objGPHosting_DNN_Contact_Form.ItemId.ToString());
        //    SearchItemCollection.Add(SearchItem);
        //}

        //return SearchItemCollection;

        //	throw new System.NotImplementedException("The method or operation is not implemented.");
        //}

        /// -----------------------------------------------------------------------------
        /// <summary>
        /// UpgradeModule implements the IUpgradeable Interface
        /// </summary>
        /// <param name="Version">The current version of the module</param>
        /// -----------------------------------------------------------------------------
        //public string UpgradeModule(string Version)
        //{
        //	throw new System.NotImplementedException("The method or operation is not implemented.");
        //}

        #endregion

    }

}
